function out = drawline(in, x0, y0, x1, y1, value )
%
%   out = drawline(in, x0, y0, x1, y1, value ) - draw a line in an image
%
%   in      -   input array/image
%   x0,y0   -   starting point for line
%   x1,y1   -   ending point for line
%   value   -   value for pixels in line
%   out     -   resulting array/image with line
%

    out = in;
    [nr, nc] = size(in);

    dx = abs( x1 - x0 );
    dy = abs( y1 - y0 );
    x = x0;
    y = y0;
    
    if (dx > dy)                     % move along x index
        e = dy * 2 - dx;
        for i = 0:dx
            if ( 0 < y && y <= nr && 0 < x && x <= nc )
                out(y,x) = value;
            endif
            if (e > 0)
                if (y1 > y0)
                    y = y + 1;
                else
                    y = y - 1;
                endif
                e = e + dy * 2 - dx * 2;
            else
                e = e + dy * 2;
            endif
            if (x1 > x0)
                x = x + 1;
            else
                x = x - 1;
            endif
        endfor
    else                            % move along y index
        e = dx * 2 - dy;
        for i = 0:dy
            if ( 0 < y && y <= nr && 0 < x && x <= nc )
                out(y,x) = value;
            endif
            if (e > 0)
                if (x1 > x0)
                    x = x + 1;
                else
                    x = x - 1;
                endif
                e = e + dx * 2 - dy * 2;
            else
                e = e + dx * 2;
            endif
            if (y1 > y0)
                y = y + 1;
            else
                y = y - 1;
            endif
        endfor
    endif

endfunction
